subroutine make_bounds(Vocal, L, Nthr, nmin, nmax, info)
  implicit none
  logical*4, intent(in)  :: Vocal
  integer*4, intent(in)  :: L, Nthr
  integer*4, intent(out) :: nmin(0:Nthr-1), nmax(0:Nthr-1)
  integer*4, intent(out) :: info

  real*8                  :: R
  integer*8               :: T, Load, M, K, S, D, L8, nmax8, pmax8
  integer*4               :: i

  info = 0

  L8 = int8(L)
  T = L8*(L8-1)/2
  Load = kidnnt(dflotk(T) / dfloat(Nthr))
  
  if(Vocal) then
     write(*,*) '         Total Load: ', T
     write(*,*) 'Load per one thread: ', Load
  end if

  nmin(0) = 2
  M       = Load
  R       = dflotk(1 + 8*M)
  nmax(0) = idnint(( 1.0d0 + dsqrt(R) ) / 2.0d0)

  if(Nthr .gt. 1) then
     do i=1,Nthr-1
        nmin(i) = nmax(i-1) + 1
        nmax8   = int8(nmax(i-1))
        K       = nmax8*(nmax8-1)/2
        M       = Load + K
        R       = dflotk(1 + 8*M)
        nmax(i) = idnint(( 1.0d0 + dsqrt(R) ) / 2.0d0)
     end do
  end if

  if(nmax(Nthr-1) .ne. L) then
     if(Vocal) write(*,*) 'Correcting nmax(Nthr-1)...'
     nmax(Nthr-1) = L
  else
     if(Vocal) write(*,*) 'Perfect match nmax(Nthr-1)=L'
     continue
  end if

  nmax8 = int8(nmax(0))
  M = nmax8*(nmax8 - 1) / 2
  if(Vocal) then
     write(*,*) 0, nmin(0), nmax(0), M
  end if
  S=M
  do i=1,Nthr-1
     nmax8 = int8(nmax(i))
     pmax8 = int8(nmax(i-1))
     M     = ( nmax8*(nmax8 - 1) - pmax8*(pmax8 - 1) ) / 2
     if(Vocal) then
        write(*,*) i, nmin(i), nmax(i), M
     end if
     S = S + M
  end do
  D = S-T
  if(Vocal) then
     write(*,*) 'Sum over threads - total workload:', D
  end if

  if(D .ne. 0) info = -1

  return
end subroutine make_bounds
